# MaxAxe (Throwing Weapons)

## Add throwing and melee secondary attacks to Axes. Throw Knives, Maces & Flaming Torches. Stack throwing weapons.

- Ever wonder why a Viking's axe (of all things) wouldn't be a weapon of choice? And why you couldn't throw them?
- MaxAxe adds throwing and melee secondary attacks to Axes & Clubs, a secondary throwing attack for Knives & Maces, and a secondary melee attack for Spears.
- Axe secondary attacks now put it on par with other weapons with strong secondary attacks, like maces and swords.
- Toggle between melee and throwing attacks with a key press.
- Optionally stack throwable weapons; up to 3 Axes, Clubs or Maces, a 'quiver' of 5 Spears, and a 'sheath' of 10 Knives per slot. (see Caution below)
- Has a weapon 'finder' to help locate thrown weapons.
- MaxAxe can automatically equip a backup weapon if you've thrown your last axe, spear or knife, so you're never fumbling to find another weapon in combat.

## New

- 0.1.6 Added key to throw current weapon (if throwable), even in melee mode.
- 0.1.6 Added "Throwing" status to status bar to display throwing weapon when in throwing mode
- 0.1.6 Revised stacked item durability from "shared" to "individual". See _Durability_ in _Stackable Weapons_ below.
- 0.1.6 Added trail to make tracking a thrown weapon in flight easier.
- 0.1.6 Revised Axe secondary melee attack speed to match maces, et.al. to avoid spamming attack.
- 0.1.6 Improved StackableWeapons configuration handling to help prevent accidental stack loss. 

- 0.1.5 Bugfix for fishing float error.

- 0.1.4 Ability to turn auto-equip on and off.
- 0.1.4 Throw flaming torches. Also torch secondary melee attack.
- 0.1.4 Bugfix to prevent upgrading entire weapon stacks and losing items.

## Configuration

### General

- **MeleeAttack**: If True, uses the melee secondary attack. Toggle in-game using the _ToggleMeleeAttack_ key.
- **ToggleMeleeAttack**: Press this key to toggle in-game between Throw and Melee mode for secondary attacks on enabled one-handed weapons. Default is LeftAlt+B.
- **ThrowOne**: Press this key (even in melee mode) to throw the currently equipped weapon (if throwable). Default is T.
- **EnableAxes**: Set to True to enable secondary melee and throwing attacks for one-handed axes.
- **EnableSpears**: Set to True to enable secondary melee attack for spears.
- **EnableKnives**: Set to True to enable secondary throwing attacks for knives.
- **EnableClubs**: Set to True to enable secondary throwing attacks for clubs, including maces, Frostner and torches.
- **StackableWeapons**: Set to True to allow throwable weapons to stack. See _Stackable Weapons_ below before enabling.
- **AutoMelee**: Set to True to automatically switch to melee mode after weapon is thrown (or to prevent throwing the last weapon in a stack).
- **AutoEquip**: Set to True to automatically equip another weapon after a throw. Will try to find the same weapon in inventory first.
- **TargetAdjustment**: Adjusts the vertical throwing impact point in relation to the target reticle (the +). Default is -7. Valnilla Valheim is 0.
- **WeaponFinder**: Type of 'locator' effect added to thrown weapon to make it easier to find. Can be 'Wishbone', 'Autopick' or 'None'. Default is Wishbone.


### Utility

- **LogLevel**: Controls the level of information in the log.

### In-game reconfiguration

You can use Configuration Manager (or similar) mod to change the configuration without exiting the game. You can force a configuration update from the chat window (press Enter) then type:

	/maxaxe config
   
You can also change most settings using this syntax:

	/maxaxe [setting]=[value] , i.e., /maxaxe enableaxes=true

Changes to _StackableWeapons_ will not take effect until the game is restarted.	


### Stackable Weapons

**READ BEFORE ENABLING STACKABLE WEAPONS**

If you set _StackableWeapons_ to 'true', one-handed axes, knives, clubs and spears will stack - in both player and chest inventory.

If you have stacked weapons in your player inventory, you will not be able to turn StackableWeapons 'off' in-game.

  Split weapon stacks into individual weapons before you disable _StackableWeapons_ or uninstall MaxAxe 

If you have turned off StackableWeapons outside of the game by modifying the configuration file, but still have stacked weapons in your player inventory _or nearby chests_, MaxAxe will automatically turn _StackableWeapons_ back on, so you don't lose the stacks. Unstack these items before turning off _StackableWeapons_. The log file will contain a warning indicating which weapon stack was found (but not which chest, if the stack is in a chest)

If you have uninstalled MaxAxe and restarted the game but had stacked weapons in chests, you may still be able to re-install MaxAxe and retrieve the stacked weapons. If the stack was in player inventory, you will need to exit the game, re-install MaxAxe, and copy the player backup (yourCharacter.fch.old) to the current character file _before_ restarting the game again.

**Durability** With release 0.1.6 stacks of weapons will have durability applied to each weapon in the stack separately (virtually). The durability bar will decrease on the weapon until it breaks. The broken weapon will be removed from the stack, and placed in a separate slot. The durability bar on the 'next' weapon in the stack will be 'full'. If additional weapons of the same type/level break, they will be stacked with existing broken weapons of the same type/level. **NOTE** _If no slot is available for the broken weapon, it will be dropped (but a weapon finder will be added)_.

When stacking weapons, the following applies:

- You can split stacks, but the split stack will have the same durability as the source stack.
- You cannot merge broken weapons into a stack with durability.
- You cannot merge durable weapons into a broken stack (prevents accidentally 'breaking' good weapons)
- You can merge durable weapons into a stack with different durability, but the merged stack will have the durability of the lesser.
- You can merge broken weapons of the same type/level together.

### Compatibility issues & defects

- _StackableWeapons_ is not compatible with Epic Loot. If you turn on stackable weapons with Epic Loot, EpicLoot will not be able to create/drop magical One Handed weapons. Existing weapons will continue to work.

- If you find a compatibility issue you can post it on NexusMods. Be sure to include the mod name and version you think may be incompatible.
- If you have a bug please report it on NexusMods. If you do post a bug report, please make sure to include the following:
    - Your version of this mod
    - What you were doing, or attempting to do when it happened
    - If it's repeatable - i.e., can you duplicate it?
    - The exact behavior you observed (or didn't observe)
    - If possible, a capture of the log file with errors (errors always begin with this mod's name)

### Notes

- You cannot upgrade weapons in a stack. Unstack a weapon before upgrading.
- Torches will remain lit for a short time after being thrown. Toss into dark areas for a bit of light!
- Axe secondary melee attacks use a sweeping overhead slash
- The spear secondary melee attack uses a powerful spear 'thrust'. Unfortunately the spear is pointed in the wrong direction(!), so this is done with the spear's butt, and therefore delivers Blunt damage!
- Weapon finders are not persisted between sessions. If you don't pick up a weapon and log off, it will no longer display a finder.

- Shameless plugs for other mods (mirror on Thunderstore):
    - WolfPack: Control all your tame creatures at once! https://www.nexusmods.com/valheim/mods/1549/
    - RequipMe: Instantly re-equip your best gear from your tombstone! https://www.nexusmods.com/valheim/mods/1615
    - Reely SpecTackleLure: Fishing skill, craftable equipment, fishing aids and deep-sea danger... https://www.nexusmods.com/valheim/mods/1655
    - UnRemove: Restore your destroyed pieces without rebuilding them. https://www.nexusmods.com/valheim/mods/1676
    
- Your comments and feedback are always welcome. Please feel free to post or send a note on NexusMods.